// copy van usmodel_hist_dsge_f19_7_71

var ewma epinfma zcapf rkf kf pkf cf invef yf labf wf rrf mc zcap rk k pk c inve y lab pinf w r a b g qs ms spinf sw kpf kp robs pinfobs labobs dw dinve dc dy;
 
varexo ea eb eg  eqs  em  epinf ew  ;  
 
parameters 
csadjcost csigma chabb cprobw csigl cprobp cindw cindp czcap cfc crpi crr cry crdy constepinf constebeta
constelab ctrend calfa s_tech s_riskp s_gov s_inv s_rant s_epinf s_ew 
crhoa crhob crhog crhoqs crhoms crhopinf crhow
cmap cmaw cgy
ctou clandaw cg curvp curvw crhols crhoas cbetabar cgamma crk cwhlc ccy ciy crkky cikbar conster;

% fixed parameters
ctou=.025;
clandaw=1.5;
cg=0.18;
curvp=10;
curvw=10;
crhols=   0.9928;
crhoas=1; 

% estimated parameters initialisation
uno=parametrar_funktion(3);
csadjcost= uno(1);
csigma=uno(2);
chabb=uno(3);    
cprobw=uno(4);
csigl=uno(5);
cprobp=uno(6);
cindw=uno(7);
cindp=uno(8);
czcap=uno(9);
cfc=uno(10);
crpi=uno(11);
crr=uno(12);
cry=uno(13);
crdy=uno(14);
constepinf=uno(15);
constebeta=uno(16);
constelab=uno(17);
ctrend=uno(18);
calfa=uno(19);

s_tech=uno(20);
s_riskp=uno(21); 
s_gov=uno(22);  
s_inv=uno(23);  
s_rant=uno(24);  
s_epinf=uno(25);  
s_ew=uno(26);
crhoa=uno(27);
crhob=uno(28);
crhog=uno(29);
crhoqs=uno(30);
crhoms=uno(31);
crhopinf=uno(32);
crhow=uno(33);
cmap=uno(34);
cmaw=uno(35);
cgy=uno(36);


cpie=1+constepinf/100;
cgamma=1+ctrend/100 ;
cbeta=1/(1+constebeta/100);

clandap=cfc;
cbetabar=cbeta*cgamma^(-csigma);
cr=cpie/(cbeta*cgamma^(-csigma));
crk=(cbeta^(-1))*(cgamma^csigma) - (1-ctou);
cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*crk^calfa))^(1/(1-calfa));
%cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*((cbeta^(-1))*(cgamma^csigma) - (1-ctou))^calfa))^(1/(1-calfa));
cikbar=(1-(1-ctou)/cgamma);
cik=(1-(1-ctou)/cgamma)*cgamma;
clk=((1-calfa)/calfa)*(crk/cw);
cky=cfc*(clk)^(calfa-1);
ciy=cik*cky;
ccy=1-cg-cik*cky;
crkky=crk*cky;
cwhlc=(1/clandaw)*(1-calfa)/calfa*crk*cky/ccy;
cwly=1-crk*cky;
conster=(cr-1)*100;

model(linear); 

%@#include "usmodel_stst.mod"

// flexible economy

	      0*(1-calfa)*a + 1*a =  calfa*rkf+(1-calfa)*(wf)  ;
	      zcapf =  (1/(czcap/(1-czcap)))* rkf  ;
	      rkf =  (wf)+labf-kf ;
	      kf =  kpf(-1)+zcapf ;
	      invef = (1/(1+cbetabar*cgamma))* (  invef(-1) + cbetabar*cgamma*invef(1)+(1/(cgamma^2*csadjcost))*pkf ) +qs ;
          pkf = -rrf-0*b+(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b +(crk/(crk+(1-ctou)))*rkf(1) +  ((1-ctou)/(crk+(1-ctou)))*pkf(1) ;
	      cf = (chabb/cgamma)/(1+chabb/cgamma)*cf(-1) + (1/(1+chabb/cgamma))*cf(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(labf-labf(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(rrf+0*b) + b ;
	      yf = ccy*cf+ciy*invef+g  +  crkky*zcapf ;
	      yf = cfc*( calfa*kf+(1-calfa)*labf +a );
	      wf = csigl*labf 	+(1/(1-chabb/cgamma))*cf - (chabb/cgamma)/(1-chabb/cgamma)*cf(-1) ;
	      kpf =  (1-cikbar)*kpf(-1)+(cikbar)*invef + (cikbar)*(cgamma^2*csadjcost)*qs ;

// sticky price - wage economy

	      mc =  calfa*rk+(1-calfa)*(w) - 1*a - 0*(1-calfa)*a ;
	      zcap =  (1/(czcap/(1-czcap)))* rk ;
	      rk =  w+lab-k ;
	      k =  kp(-1)+zcap ;
	      inve = (1/(1+cbetabar*cgamma))* (  inve(-1) + cbetabar*cgamma*inve(1)+(1/(cgamma^2*csadjcost))*pk ) +qs ;
          pk = -r+pinf(1)-0*b +(1/((1-chabb/cgamma)/(csigma*(1+chabb/cgamma))))*b + (crk/(crk+(1-ctou)))*rk(1) +  ((1-ctou)/(crk+(1-ctou)))*pk(1) ;
	      c = (chabb/cgamma)/(1+chabb/cgamma)*c(-1) + (1/(1+chabb/cgamma))*c(+1) +((csigma-1)*cwhlc/(csigma*(1+chabb/cgamma)))*(lab-lab(+1)) - (1-chabb/cgamma)/(csigma*(1+chabb/cgamma))*(r-pinf(+1) + 0*b) +b ;
	      y = ccy*c+ciy*inve+g  +  1*crkky*zcap ;
	      y = cfc*( calfa*k+(1-calfa)*lab +a );
	      pinf =  (1/(1+cbetabar*cgamma*cindp)) * ( cbetabar*cgamma*pinf(1) +cindp*pinf(-1) 
               +((1-cprobp)*(1-cbetabar*cgamma*cprobp)/cprobp)/((cfc-1)*curvp+1)*(mc)  )  + spinf ; 
	      w =  (1/(1+cbetabar*cgamma))*w(-1)
               +(cbetabar*cgamma/(1+cbetabar*cgamma))*w(1)
               +(cindw/(1+cbetabar*cgamma))*pinf(-1)
               -(1+cbetabar*cgamma*cindw)/(1+cbetabar*cgamma)*pinf
               +(cbetabar*cgamma)/(1+cbetabar*cgamma)*pinf(1)
               +(1-cprobw)*(1-cbetabar*cgamma*cprobw)/((1+cbetabar*cgamma)*cprobw)*(1/((clandaw-1)*curvw+1))*
               (csigl*lab + (1/(1-chabb/cgamma))*c - ((chabb/cgamma)/(1-chabb/cgamma))*c(-1) -w) 
               + 1*sw ;
	      r =  crpi*(1-crr)*pinf
               +cry*(1-crr)*(y-yf)     
               +crdy*(y-yf-y(-1)+yf(-1))
               +crr*r(-1)
               +ms  ;
	      a = crhoa*a(-1)  + ea;
	      b = crhob*b(-1) + eb;
	      g = crhog*(g(-1)) + eg + cgy*ea;
	      qs = crhoqs*qs(-1) + eqs;
	      ms = crhoms*ms(-1) + em;
	      spinf = crhopinf*spinf(-1) + epinfma - cmap*epinfma(-1);
	          epinfma=epinf;
	      sw = crhow*sw(-1) + ewma - cmaw*ewma(-1) ;
	          ewma=ew; 
	      kp =  (1-cikbar)*kp(-1)+cikbar*inve + cikbar*cgamma^2*csadjcost*qs ;

// measurment equations

dy=y-y(-1)+ctrend;
dc=c-c(-1)+ctrend;
dinve=inve-inve(-1)+ctrend;
dw=w-w(-1)+ctrend;
pinfobs = 1*(pinf) + constepinf;
robs =    1*(r) + conster;
labobs = lab + constelab;

end; 

resid(0);
steady;

check;


shocks;
var ea;
stderr 0.45;
var eb;
stderr s_riskp;
var eg;
stderr 0.2400;
var eqs;
stderr 0.4500;
var em;
stderr 0.2400;
var epinf;
stderr 0.1400;
var ew;
stderr 0.2400;
end;

estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
csadjcost,6.3325;
% csigma,1.2312;
% chabb,0.7205;
% cprobw,0.7937;
% csigl,2.8401;
% cprobp,0.7813;
% cindw,0.4425;
% cindp,0.3291;
% czcap,0.2648;
% cfc,1.4672;
% crpi,1.7985;
% crr,0.8258;
% cry,0.0893;
% crdy,0.2239;
% constepinf,0.7;
% constebeta,0.7420;
% constelab,1.2918;
% ctrend,0.3982;
% calfa,0.24;
% stderr ea,0.4618;
% stderr eb,0.1818513;
% stderr eg,0.6090;
% stderr eqs,0.46017;
% stderr em,0.2397;
% stderr epinf,0.1455;
% stderr ew,0.2089;
% crhoa,.9676;
% crhob,.2703;
% crhog,.9930;
% crhoqs,.5724;
% crhoms,.3;
% crhopinf,.8692;
% crhow,.9546;
% cmap,.7652;
% cmaw,.8936;
% cgy,0.05;
end;

varobs dy dc dinve labobs pinfobs dw robs;

estimation(order=1, datafile=usmodel_data, mh_replic=10, mh_nblocks=2, mh_jscale=0.8, nograph, nodiagnostic);

load sw_check_mode xparam1
global dataset_  bayestopt_ 
[likelihood,junk1,junk2,exit_flag,ys,trend_coeff,info] = dsge_likelihood(xparam1,dataset_,options_,M_,estim_params_,bayestopt_,oo_);


%shock_decomposition y;
//shock_decomposition(labels=(ea)) y;